--[[----------------------------------------------------------
	RadarMiniMap
  ]]----------------------------------------------------------
  
-- Create Global
RMM = {}
RMM.name = "RadarMiniMap"
RMM.version	= 0.466
RMM.lam = LibStub("LibAddonMenu-2.0")

--Addon Initialize
function RMM.OnInitialize( eventCode, addOnName )
    
	if addOnName == RMM.name then zo_callLater(RMM.AddonLoad,1000) end
	
end

--Addon Start
function RMM.AddonLoad()
	
	RMM.LoadSettings()
	RMM.CreateUI()
	RMM.CreateMenu()
	
	RMM.RegisterForUpdate(false, "RMM_OnSMTPLUpdate", RMM.mainSet.smtplUpdateRate, function() if not RMM.c:IsHidden() then SetMapToPlayerLocation() end end)
	RMM.RegisterForUpdate(false, "RMM_OnPosUpdate", RMM.mainSet.posUpdateRate, RMM.OnPosUpdate)
	RMM.RegisterForUpdate(false, "RMM_OnLinkUpdate", RMM.mainSet.pinUpdateRate, RMM.OnLinkUpdate)
	RMM.RegisterForUpdate(false, "RMM_OnGroupUpdate", RMM.mainSet.groupUpdateRate, RMM.OnGroupUpdate)
	RMM.RegisterForUpdate(false, "RMM_OnAnimationUpdate", 200, RMM.OnAnimationUpdate)
	
	ZO_WorldMapInfo:SetHandler("OnShow", function() ZO_WorldMap_UpdateMap() end)
	ZO_WorldMapInfo:SetHandler("OnHide", function() RMM.WorldMapUpdate() end)
	
	ZO_PreHook(ZO_WorldMapPins, "MapPinLookupToPinKey", function(self, lookupType, majorIndex, keyIndex, pinKey) RMM.CreatePin(self, lookupType, majorIndex, keyIndex, pinKey) end)
    ZO_PreHook(ZO_WorldMapPins, "RemovePins", function(self, lookupType, majorIndex, keyIndex) RMM.RemovePins(self, lookupType, majorIndex, keyIndex) end)

end

--Name Keybinds
ZO_CreateStringId("SI_BINDING_NAME_TOGGLE_ADDON", "Toggle Addon")
ZO_CreateStringId("SI_BINDING_NAME_MAP_ZOOM_IN", "Map Zoom In")
ZO_CreateStringId("SI_BINDING_NAME_MAP_ZOOM_OUT", "Map Zoom Out")
ZO_CreateStringId("SI_BINDING_NAME_PIN_ZOOM_IN", "Pin Zoom In")
ZO_CreateStringId("SI_BINDING_NAME_PIN_ZOOM_OUT", "Pin Zoom Out")
ZO_CreateStringId("SI_BINDING_NAME_OPEN_SETTINGS", "Open Settings")
ZO_CreateStringId("SI_BINDING_NAME_TOGGLE_ROTATION", "Toggle Rotation")
ZO_CreateStringId("SI_BINDING_NAME_TOGGLE_CAMERA", "Toggle Camera")
ZO_CreateStringId("SI_BINDING_NAME_TOGGLE_PINS", "Toggle Pins")

--Register events
EVENT_MANAGER:RegisterForEvent( "RMM_Init" , EVENT_ADD_ON_LOADED, RMM.OnInitialize )