--[[----------------------------------------------------------
	RadarMiniMap Group
  ]]----------------------------------------------------------

function RMM.CreateGroupPins(groupNum)
	
	RMM.ClearGroupPins()
	
	if not IsUnitGrouped("player") then return end
	
	local unitSortList = {}
	for i = 1, 24 do
		if GetGroupUnitTagByIndex(i) then
			unitSortList[GetGroupUnitTagByIndex(i)] = i
		end
	end
	
	for i=1, groupNum do
		local unit = "group"..i
		if DoesUnitExist(unit) and IsUnitOnline(unit) and GetUnitName(unit) ~= GetUnitName("player") and GetUnitZone(unit) == GetUnitZone("player") then
			RMM.CreateGroupPinControls(i)
			RMM.groupPins[i]:SetHidden(false)
			RMM.groupPins[i].normX, RMM.groupPins[i].normY = GetMapPlayerPosition(unit)
	
			if IsUnitGroupLeader(unit) then
				if RMM.mainSet.groupLeaderCustomIcon then
					RMM.groupPins[i]:SetTexture("RadarMiniMap/asset/dot.dds")
					if unitSortList[unit] then
						RMM.groupPinsLabel[i]:SetText(unitSortList[unit])
					else
						RMM.groupPinsLabel[i]:SetText("x")
					end
					RMM.groupPinsLabel[i]:SetHidden(false)
					RMM.groupPinsLabel[i]:SetHorizontalAlignment(CENTER)
					RMM.groupPinsLabel[i]:SetVerticalAlignment(CENTER)
					RMM.groupPins[i].leader = true
					RMM.groupPins[i]:SetDrawLayer(4)
					RMM.groupPins[i]:SetDimensions(RMM.mainSet.groupLeaderSize, RMM.mainSet.groupLeaderSize)
					RMM.groupPins[i]:SetColor(RMM.mainSet.groupLeaderColor.r, RMM.mainSet.groupLeaderColor.g, RMM.mainSet.groupLeaderColor.b, RMM.mainSet.groupLeaderColor.a)
					RMM.groupPins[i]:SetMouseEnabled(true)
					RMM.groupPinsLabel[i]:SetDrawLayer(4)
					RMM.groupPinsLabel[i]:SetColor(RMM.mainSet.groupLeaderTextColor.r, RMM.mainSet.groupLeaderTextColor.g, RMM.mainSet.groupLeaderTextColor.b, RMM.mainSet.groupLeaderTextColor.a)
					RMM.groupPinsLabel[i]:SetFont("EsoUI/Common/Fonts/arialn.ttf" .. "|" .. RMM.mainSet.groupLeaderTextSize .. "|" ..  "none")
					RMM.groupPinsLabel[i]:ClearAnchors()
					RMM.groupPinsLabel[i]:SetAnchor(CENTER, RMM.groupPins[i], CENTER, RMM.mainSet.groupLeaderTextOffsetX, RMM.mainSet.groupLeaderTextOffsetY)
					RMM.groupPinsLabel[i]:SetMouseEnabled(true)
					if IsUnitDead(unit) then
						RMM.groupPins[i]:SetColor(RMM.mainSet.groupLeaderDeadColor.r, RMM.mainSet.groupLeaderDeadColor.g, RMM.mainSet.groupLeaderDeadColor.b, RMM.mainSet.groupLeaderDeadColor.a)
					end
				else
					RMM.groupPins[i]:SetColor(1,1,1,1)
					RMM.groupPins[i]:SetTexture("EsoUI/Art/Compass/groupleader.dds")
					RMM.groupPins[i]:SetDimensions(32 * RMM.mainSet.poiSize, 32 * RMM.mainSet.poiSize)
					RMM.groupPins[i].leader = true
					RMM.groupPins[i]:SetDrawLayer(4)
					RMM.groupPins[i]:SetMouseEnabled(true)
				end
			else
				if RMM.mainSet.groupCustomIcon then
					RMM.groupPins[i]:SetTexture("RadarMiniMap/asset/dot.dds")
					if unitSortList[unit] then
						RMM.groupPinsLabel[i]:SetText(unitSortList[unit])
					else
						RMM.groupPinsLabel[i]:SetText("x")
					end
					RMM.groupPinsLabel[i]:SetHidden(false)
					RMM.groupPinsLabel[i]:SetHorizontalAlignment(CENTER)
					RMM.groupPinsLabel[i]:SetVerticalAlignment(CENTER)
					RMM.groupPins[i].leader = false
					RMM.groupPins[i]:SetDrawLayer(3)
					RMM.groupPins[i]:SetDimensions(RMM.mainSet.groupSize, RMM.mainSet.groupSize)
					RMM.groupPins[i]:SetColor(RMM.mainSet.groupColor.r, RMM.mainSet.groupColor.g, RMM.mainSet.groupColor.b, RMM.mainSet.groupColor.a)
					RMM.groupPins[i]:SetMouseEnabled(true)
					RMM.groupPinsLabel[i]:SetDrawLayer(3)
					RMM.groupPinsLabel[i]:SetColor(RMM.mainSet.groupTextColor.r, RMM.mainSet.groupTextColor.g, RMM.mainSet.groupTextColor.b, RMM.mainSet.groupTextColor.a)
					RMM.groupPinsLabel[i]:SetFont("EsoUI/Common/Fonts/arialn.ttf" .. "|" .. RMM.mainSet.groupTextSize .. "|" ..  "none")
					RMM.groupPinsLabel[i]:ClearAnchors()
					RMM.groupPinsLabel[i]:SetAnchor(CENTER, RMM.groupPins[i], CENTER, RMM.mainSet.groupTextOffsetX, RMM.mainSet.groupTextOffsetY)
					RMM.groupPinsLabel[i]:SetMouseEnabled(true)
					if IsUnitDead(unit) then
						RMM.groupPins[i]:SetColor(RMM.mainSet.groupDeadColor.r, RMM.mainSet.groupDeadColor.g, RMM.mainSet.groupDeadColor.b, RMM.mainSet.groupDeadColor.a)
					end				
				else
					RMM.groupPins[i]:SetColor(1,1,1,1)
					RMM.groupPins[i]:SetTexture("EsoUI/Art/MapPins/UI-WorldMapGroupPip.dds")
					RMM.groupPins[i]:SetDimensions(32 * RMM.mainSet.poiSize, 32 * RMM.mainSet.poiSize)
					RMM.groupPins[i].leader = false
					RMM.groupPins[i]:SetDrawLayer(3)
					RMM.groupPins[i]:SetMouseEnabled(true)
				end
			end
			
			RMM.groupPins[i]:SetHandler("OnMouseEnter",
			function()
				RMM.OnMouseEnter()
				InitializeTooltip(InformationTooltip, RMM.c.menuv, RMM.tooltipAnchor, 0, 0)
				InformationTooltip:AppendUnitName(GetUnitName(unit))
			end)
			
			RMM.groupPins[i]:SetHandler("OnMouseExit",
			function()
				RMM.OnMouseExit()
				ClearTooltip(InformationTooltip)
			end)
			
			if RMM.groupPinsLabel[i] then			
				RMM.groupPinsLabel[i]:SetHandler("OnMouseEnter",
				function()
					RMM.OnMouseEnter()
					InitializeTooltip(InformationTooltip, RMM.c.menuv, RMM.tooltipAnchor, 0, 0)
					InformationTooltip:AppendUnitName(GetUnitName(unit))
				end)
				
				RMM.groupPinsLabel[i]:SetHandler("OnMouseExit",
				function()
					RMM.OnMouseExit()
					ClearTooltip(InformationTooltip)
				end)
			end
			
		end
	end
	
end

function RMM.CreateGroupPinControls(i)

	if not WINDOW_MANAGER:GetControlByName("RMM_GROUP_PINS_"..i) then
		RMM.groupPins[i] = WINDOW_MANAGER:CreateControl("RMM_GROUP_PINS_"..i, RMM.c.map, CT_TEXTURE)
	else
		RMM.groupPins[i] = WINDOW_MANAGER:GetControlByName("RMM_GROUP_PINS_"..i)
	end
	
	if not WINDOW_MANAGER:GetControlByName("RMM_GROUP_PINS_LABEL_"..i) then
		RMM.groupPinsLabel[i] = WINDOW_MANAGER:CreateControl("RMM_GROUP_PINS_LABEL_"..i, RMM.groupPins[i], CT_LABEL)
	else
		RMM.groupPinsLabel[i] = WINDOW_MANAGER:GetControlByName("RMM_GROUP_PINS_LABEL_"..i)
	end
	
end

function RMM.ClearGroupPins()
	
	if not RMM.groupPins then RMM.groupPins = {} end
	if not RMM.groupPinsLabel then RMM.groupPinsLabel = {} end

	for k,v in pairs(RMM.groupPins) do
		local c = WINDOW_MANAGER:GetControlByName(v:GetName())
		if c then
				c:SetHidden(true)
		end
	end
	
	for k,v in pairs(RMM.groupPinsLabel) do
		local c = WINDOW_MANAGER:GetControlByName(v:GetName())
		if c then
				c:SetHidden(true)
		end
	end

	RMM.groupPins = {}
	RMM.groupPinsLabel = {}
	
end

function RMM.SetGroupPinPos(rotate)

	if not RMM.groupPins then return end
		
	for k,v in pairs(RMM.groupPins) do
	
		local scX, scY = RMM.c.map:GetDimensions()
		local x = 0
		local y = 0
		local z = 0
		
		if RMM.mainSet.squareMap then
			xx = (scX / 2) + RMM.mainSet.pixelBorder
			yy = (scY / 2) + RMM.mainSet.pixelBorder
		else
			xx = (scX / 2) + ((scX / 2) * (RMM.mainSet.percentBorder / 100))
			yy = (scY / 2) + ((scY / 2) * (RMM.mainSet.percentBorder / 100))
		end
		
		if rotate then
			local fx = (RMM.groupPins[k].normX * RMM.map[RMM.mapName]["mapSizeWidth"] * RMM.mapZoom) - RMM.player.posX
			local fy = (RMM.groupPins[k].normY * RMM.map[RMM.mapName]["mapSizeHigh"] * RMM.mapZoom) - RMM.player.posY
			x = (math.cos(-RMM.player.heading) * fx) - (math.sin(-RMM.player.heading) * fy)
			y = (math.sin(-RMM.player.heading) * fx) + (math.cos(-RMM.player.heading) * fy)
			z = math.sqrt((x^2)+(y^2))
		else
			local fx = (RMM.groupPins[k].normX * RMM.map[RMM.mapName]["mapSizeWidth"] * RMM.mapZoom) - RMM.player.posX
			local fy = (RMM.groupPins[k].normY * RMM.map[RMM.mapName]["mapSizeHigh"] * RMM.mapZoom) - RMM.player.posY
			x = (math.cos(0.00001) * fx) - (math.sin(0.00001) * fy)
			y = (math.sin(0.00001) * fx) + (math.cos(0.00001) * fy)
			z = math.sqrt((x^2)+(y^2))
		end
		
		if RMM.groupPins[k].leader then

			if RMM.mainSet.borderGroupLeader then
				if not RMM.mainSet.squareMap then
					if z > xx then
						x = (xx/z)*x
						y = (xx/z)*y
					end
				else
					if x > xx or x < -xx or y > yy or y < -yy then
						if x > xx or y > yy then
							if x/xx < y/yy then
								x = yy / y * x
								y = yy
							end
							if y/yy < x/xx then
								y = xx / x * y
								x = xx
							end
						end
						
						if x < -xx or y < -yy then
							if x/xx > y/yy then
								x = -yy / y * x
								y = -yy
							end		
							if y/yy > x/xx then
								y = -xx / x * y
								x = -xx
							end
						end
					end
				end
			end			
		
		else
			
			if RMM.mainSet.borderGroup then
				if not RMM.mainSet.squareMap then
					if z > xx then
						x = (xx/z)*x
						y = (xx/z)*y
					end
				else
					if x > xx or x < -xx or y > yy or y < -yy then
						if x > xx or y > yy then
							if x/xx < y/yy then
								x = yy / y * x
								y = yy
							end
							if y/yy < x/xx then
								y = xx / x * y
								x = xx
							end
						end
						
						if x < -xx or y < -yy then
							if x/xx > y/yy then
								x = -yy / y * x
								y = -yy
							end		
							if y/yy > x/xx then
								y = -xx / x * y
								x = -xx
							end
						end
					end
				end
			end			
			
		end
		
		RMM.groupPins[k]:ClearAnchors()
		RMM.groupPins[k]:SetAnchor(CENTER, RMM.c.ppin, CENTER, x, y)
		
	end
	
end