--[[----------------------------------------------------------
	RadarMiniMap UI
  ]]-----------------------------------------------------------

RMM.inactive = {}
  
function RMM.CreateUI()

	local wm = WINDOW_MANAGER
	
	--MapFrame
	
	--main
	if not RMM.c then
		RMM.c = wm:CreateTopLevelWindow("RMM_ROOT")
		RMM.c:SetMovable(true)
		RMM.c:SetMouseEnabled(true)
		RMM.c:SetClampedToScreen(true)
		RMM.c:SetResizeHandleSize(MOUSE_CURSOR_RESIZE_NS)
		RMM.c:SetHandler("OnMouseEnter", RMM.OnMouseEnter)
		RMM.c:SetHandler("OnMouseExit", RMM.OnMouseExit)
		RMM.c:SetHandler("OnResizeStart", RMM.OnResizeStart)
		RMM.c:SetHandler("OnResizeStop", RMM.OnResizeStop)
		RMM.c:SetHandler("OnMouseWheel", RMM.OnMapMouseWheel)
		RMM.c:SetHandler("OnMoveStop", RMM.OnMoveStop)
	end
	RMM.c:ClearAnchors()
	RMM.c:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT,RMM.mainSet.positionX,RMM.mainSet.positionY)
	RMM.c:SetDimensions(RMM.mainSet.sizeX,RMM.mainSet.sizeY)
	
	--map
    if not RMM.c.map then
		RMM.c.map = wm:CreateControl("RMM_MAP", RMM.c, CT_SCROLL)
		RMM.c.map:SetAnchor (CENTER, RMM.c, CENTER, 0, 0)
		RMM.c.map:SetDrawLayer(1)
	end
	if RMM.mainSet.squareMap then
		if RMM.mainSet.squareMapBorder then
			RMM.c.map:SetDimensions(RMM.mainSet.sizeX - (RMM.mainSet.squareMapBorderSize * 2),RMM.mainSet.sizeY - (RMM.mainSet.squareMapBorderSize * 2))
		else
			RMM.c.map:SetDimensions(RMM.mainSet.sizeX,RMM.mainSet.sizeY)
		end
		RMM.c.map:SetAlpha(RMM.mainSet.squareMapAlpha)
	else
		RMM.c.map:SetDimensions(RMM.mainSet.sizeX / 256 * 212,RMM.mainSet.sizeY / 256 * 212)
	end

	--borderTop
	if not RMM.c.borderTop then
		RMM.c.borderTop = wm:CreateControl("RMM_BORDERTOP", RMM.c, CT_BACKDROP)
		RMM.c.borderTop:SetDrawLayer(1)
		RMM.c.borderTop:SetEdgeColor(0,0,0,0)		
	end
	if RMM.mainSet.squareMap and RMM.mainSet.squareMapBorder then
		RMM.c.borderTop:SetHidden(false)
		RMM.c.borderTop.active = true
		RMM.c.borderTop:SetCenterColor(RMM.mainSet.squareMapBorderColor.r, RMM.mainSet.squareMapBorderColor.g, RMM.mainSet.squareMapBorderColor.b, RMM.mainSet.squareMapBorderColor.a)
		RMM.c.borderTop:SetAnchor(BOTTOM, RMM.c.map, TOP, 0, 0)
		RMM.c.borderTop:SetDimensions(RMM.mainSet.sizeX, RMM.mainSet.squareMapBorderSize)
	else
		RMM.c.borderTop:SetHidden(true)
		RMM.c.borderTop.active = false
	end
	
	--borderBottom
	if not RMM.c.borderBottom then
		RMM.c.borderBottom = wm:CreateControl("RMM_BORDERBOTTOM", RMM.c, CT_BACKDROP)
		RMM.c.borderBottom:SetDrawLayer(1)
		RMM.c.borderBottom:SetEdgeColor(0,0,0,0)
	end
	if RMM.mainSet.squareMap and RMM.mainSet.squareMapBorder then
		RMM.c.borderBottom:SetHidden(false)
		RMM.c.borderBottom.active = true
		RMM.c.borderBottom:SetCenterColor(RMM.mainSet.squareMapBorderColor.r, RMM.mainSet.squareMapBorderColor.g, RMM.mainSet.squareMapBorderColor.b, RMM.mainSet.squareMapBorderColor.a)
		RMM.c.borderBottom:SetAnchor(TOP, RMM.c.map, BOTTOM, 0, 0)
		RMM.c.borderBottom:SetDimensions(RMM.mainSet.sizeX, RMM.mainSet.squareMapBorderSize)
	else
		RMM.c.borderBottom:SetHidden(true)
		RMM.c.borderBottom.active = false
	end
	
	--borderLeft
	if not RMM.c.borderLeft then
		RMM.c.borderLeft = wm:CreateControl("RMM_BORDERLEFT", RMM.c, CT_BACKDROP)
		RMM.c.borderLeft:SetDrawLayer(1)
		RMM.c.borderLeft:SetEdgeColor(0,0,0,0)
	end
	if RMM.mainSet.squareMap and RMM.mainSet.squareMapBorder then
		RMM.c.borderLeft:SetHidden(false)
		RMM.c.borderLeft.active = true
		RMM.c.borderLeft:SetCenterColor(RMM.mainSet.squareMapBorderColor.r, RMM.mainSet.squareMapBorderColor.g, RMM.mainSet.squareMapBorderColor.b, RMM.mainSet.squareMapBorderColor.a)
		RMM.c.borderLeft:SetAnchor(RIGHT, RMM.c.map, LEFT, 0, 0)
		RMM.c.borderLeft:SetDimensions(RMM.mainSet.squareMapBorderSize, RMM.mainSet.sizeY - (RMM.mainSet.squareMapBorderSize * 2))
	else
		RMM.c.borderLeft:SetHidden(true)
		RMM.c.borderLeft.active = false
	end
	
	--borderRight
	if not RMM.c.borderRight then
		RMM.c.borderRight = wm:CreateControl("RMM_BORDERRIGHT", RMM.c, CT_BACKDROP)
		RMM.c.borderRight:SetDrawLayer(1)
		RMM.c.borderRight:SetEdgeColor(0,0,0,0)
	end
	if RMM.mainSet.squareMap and RMM.mainSet.squareMapBorder then
		RMM.c.borderRight:SetHidden(false)
		RMM.c.borderRight.active = true
		RMM.c.borderRight:SetCenterColor(RMM.mainSet.squareMapBorderColor.r, RMM.mainSet.squareMapBorderColor.g, RMM.mainSet.squareMapBorderColor.b, RMM.mainSet.squareMapBorderColor.a)
		RMM.c.borderRight:SetAnchor(LEFT, RMM.c.map, RIGHT, 0, 0)
		RMM.c.borderRight:SetDimensions(RMM.mainSet.squareMapBorderSize, RMM.mainSet.sizeY - (RMM.mainSet.squareMapBorderSize * 2))
	else
		RMM.c.borderRight:SetHidden(true)
		RMM.c.borderRight.active = false
	end
	
	--hover
    if not RMM.c.hover then
		RMM.c.hover = wm:CreateControl("RMM_HOVER", RMM.c, CT_BACKDROP)
		RMM.c.hover:SetAnchorFill(RMM.c)
		RMM.c.hover:SetDrawLayer(0)
		RMM.c.hover:SetHidden(true)
		RMM.c.hover:SetCenterColor(0, 0, 0, 0.4)
		RMM.c.hover:SetEdgeColor(0, 0, 0, 0)	
	end
	
	--background
    if not RMM.c.back then
		RMM.c.back = wm:CreateControl("RMM_BACK", RMM.c, CT_TEXTURE)
		RMM.c.back:SetTexture("RadarMiniMap/asset/back.dds")
		RMM.c.back:SetAnchorFill(RMM.c.map)
		RMM.c.back:SetDrawLayer(0)
	end
	if RMM.mainSet.squareMap and RMM.mainSet.squareMapAlpha < 1 then
		RMM.c.back:SetHidden(true)
		RMM.c.back.active = false
		RMM.c.back:SetAlpha(RMM.mainSet.squareMapAlpha)
	else
		RMM.c.back:SetHidden(false)
		RMM.c.back.active = true
	end
	
	--overlay
	if not RMM.c.overlay then
		RMM.c.overlay = wm:CreateControl("RMM_OVERLAY", RMM.c, CT_TEXTURE)
		RMM.c.overlay:SetAnchorFill(RMM.c)
		RMM.c.overlay:SetDrawLayer(2)
	end
	if RMM.textures[RMM.mainSet.overlayAddon] then
		RMM.c.overlay:SetTexture(RMM.textures[RMM.mainSet.overlayAddon].overlay[RMM.mainSet.overlayTexture])
	else
		RMM.mainSet.overlayAddon = RMM.mainDefaults.overlayAddon
		RMM.mainSet.overlayTexture = RMM.mainDefaults.overlayTexture
		RMM.c.overlay:SetTexture(RMM.textures[RMM.mainSet.overlayAddon].overlay[RMM.mainSet.overlayTexture])
	end
	if RMM.mainSet.squareMap then
		RMM.c.overlay:SetHidden(true)
		RMM.c.overlay.active = false
	else
		RMM.c.overlay:SetHidden(false)
		RMM.c.overlay.active = true
	end	

	--wheel
	if not RMM.c.wheel then
		RMM.c.wheel = wm:CreateControl("RMM_WHEEL", RMM.c, CT_TEXTURE)
		RMM.c.wheel:SetAnchorFill(RMM.c)	
		RMM.c.wheel:SetDrawLayer(3)
	end
	if RMM.textures[RMM.mainSet.wheelAddon] then
		RMM.c.wheel:SetTexture(RMM.textures[RMM.mainSet.wheelAddon].wheel[RMM.mainSet.wheelTexture])
	else
		RMM.mainSet.wheelAddon = RMM.mainDefaults.wheelAddon
		RMM.mainSet.wheelTexture = RMM.mainDefaults.wheelTexture
		RMM.c.wheel:SetTexture(RMM.textures[RMM.mainSet.wheelAddon].wheel[RMM.mainSet.wheelTexture])		
	end
	if RMM.mainSet.squareMap then
		RMM.c.wheel:SetHidden(true)
		RMM.c.wheel.active = false
	else
		RMM.c.wheel:SetHidden(false)
		RMM.c.wheel.active = true
	end	
		
	--square compass
	if not RMM.c.compass then
		RMM.c.compass = wm:CreateControl("RMM_SQUARE_COMPASS", RMM.c, CT_SCROLL)
		RMM.c.compass:SetAnchorFill(RMM.c)
		RMM.c.compass:SetDrawLayer(4)
	end
	if RMM.mainSet.squareMap and RMM.mainSet.squareMapCompass then
		RMM.c.compass:SetHidden(false)
		RMM.c.compass.active = true
	else
		RMM.c.compass:SetHidden(true)
		RMM.c.compass.active = false
	end
	
	--north
	if not RMM.c.compass.north then
		RMM.c.compass.north = wm:CreateControl("RMM_SQUARE_COMPASS_NORTH", RMM.c.compass, CT_LABEL)
		RMM.c.compass.north:SetHorizontalAlignment( CENTER )
		RMM.c.compass.north:SetVerticalAlignment( CENTER )
		RMM.c.compass.north:SetDrawLayer(1)
		RMM.c.compass.north:SetText("N")
		RMM.c.compass.north.x = 0
		RMM.c.compass.north.y = -1
	end
	RMM.c.compass.north:SetFont(RMM.fonts[RMM.mainSet.squareMapCompassFont] .. "|" .. RMM.mainSet.squareMapCompassFontSize .. "|" ..  RMM.fontTypes[RMM.mainSet.squareMapCompassFontType])
	RMM.c.compass.north:SetColor(RMM.mainSet.squareMapCompassFontColor.r,RMM.mainSet.squareMapCompassFontColor.g,RMM.mainSet.squareMapCompassFontColor.b,RMM.mainSet.squareMapCompassFontColor.a)
	
	--west
	if not RMM.c.compass.west then
		RMM.c.compass.west = wm:CreateControl("RMM_SQUARE_COMPASS_WEST", RMM.c.compass, CT_LABEL)
		RMM.c.compass.west:SetHorizontalAlignment( CENTER )
		RMM.c.compass.west:SetVerticalAlignment( CENTER )
		RMM.c.compass.west:SetDrawLayer(1)
		RMM.c.compass.west:SetText("W")
		RMM.c.compass.west.x = -1
		RMM.c.compass.west.y = 0
	end
	RMM.c.compass.west:SetFont(RMM.fonts[RMM.mainSet.squareMapCompassFont] .. "|" .. RMM.mainSet.squareMapCompassFontSize .. "|" ..  RMM.fontTypes[RMM.mainSet.squareMapCompassFontType])
	RMM.c.compass.west:SetColor(RMM.mainSet.squareMapCompassFontColor.r,RMM.mainSet.squareMapCompassFontColor.g,RMM.mainSet.squareMapCompassFontColor.b,RMM.mainSet.squareMapCompassFontColor.a)
	
	--east
	if not RMM.c.compass.east then
		RMM.c.compass.east = wm:CreateControl("RMM_SQUARE_COMPASS_EAST", RMM.c.compass, CT_LABEL)
		RMM.c.compass.east:SetHorizontalAlignment( CENTER )
		RMM.c.compass.east:SetVerticalAlignment( CENTER )
		RMM.c.compass.east:SetDrawLayer(1)
		RMM.c.compass.east:SetText("E")
		RMM.c.compass.east.x = 1
		RMM.c.compass.east.y = 0
	end
	RMM.c.compass.east:SetFont(RMM.fonts[RMM.mainSet.squareMapCompassFont] .. "|" .. RMM.mainSet.squareMapCompassFontSize .. "|" ..  RMM.fontTypes[RMM.mainSet.squareMapCompassFontType])
	RMM.c.compass.east:SetColor(RMM.mainSet.squareMapCompassFontColor.r,RMM.mainSet.squareMapCompassFontColor.g,RMM.mainSet.squareMapCompassFontColor.b,RMM.mainSet.squareMapCompassFontColor.a)
	
	--south
	if not RMM.c.compass.south then
		RMM.c.compass.south = wm:CreateControl("RMM_SQUARE_COMPASS_SOUTH", RMM.c.compass, CT_LABEL)
		RMM.c.compass.south:SetHorizontalAlignment( CENTER )
		RMM.c.compass.south:SetVerticalAlignment( CENTER )
		RMM.c.compass.south:SetDrawLayer(1)
		RMM.c.compass.south:SetText("S")
		RMM.c.compass.south.x = 0
		RMM.c.compass.south.y = 1
	end
	RMM.c.compass.south:SetFont(RMM.fonts[RMM.mainSet.squareMapCompassFont] .. "|" .. RMM.mainSet.squareMapCompassFontSize .. "|" ..  RMM.fontTypes[RMM.mainSet.squareMapCompassFontType])
	RMM.c.compass.south:SetColor(RMM.mainSet.squareMapCompassFontColor.r,RMM.mainSet.squareMapCompassFontColor.g,RMM.mainSet.squareMapCompassFontColor.b,RMM.mainSet.squareMapCompassFontColor.a)
	
	--northwest
	if not RMM.c.compass.northwest then
	RMM.c.compass.northwest = wm:CreateControl("RMM_SQUARE_COMPASS_NORTHWEST", RMM.c.compass, CT_LABEL)
	RMM.c.compass.northwest:SetHorizontalAlignment( CENTER )
	RMM.c.compass.northwest:SetVerticalAlignment( CENTER )
	RMM.c.compass.northwest:SetDrawLayer(1)
	RMM.c.compass.northwest:SetText("NW")
	RMM.c.compass.northwest.x = -1
	RMM.c.compass.northwest.y = -1
	end
	RMM.c.compass.northwest:SetFont(RMM.fonts[RMM.mainSet.squareMapCompassFont] .. "|" .. RMM.mainSet.squareMapCompassFontSize .. "|" ..  RMM.fontTypes[RMM.mainSet.squareMapCompassFontType])
	RMM.c.compass.northwest:SetColor(RMM.mainSet.squareMapCompassFontColor.r,RMM.mainSet.squareMapCompassFontColor.g,RMM.mainSet.squareMapCompassFontColor.b,RMM.mainSet.squareMapCompassFontColor.a)
	
	--northeast
	if not RMM.c.compass.northeast then
		RMM.c.compass.northeast = wm:CreateControl("RMM_SQUARE_COMPASS_NORTHEAST", RMM.c.compass, CT_LABEL)
		RMM.c.compass.northeast:SetHorizontalAlignment( CENTER )
		RMM.c.compass.northeast:SetVerticalAlignment( CENTER )
		RMM.c.compass.northeast:SetDrawLayer(1)
		RMM.c.compass.northeast:SetText("NE")
		RMM.c.compass.northeast.x = 1
		RMM.c.compass.northeast.y = -1
	end
	RMM.c.compass.northeast:SetFont(RMM.fonts[RMM.mainSet.squareMapCompassFont] .. "|" .. RMM.mainSet.squareMapCompassFontSize .. "|" ..  RMM.fontTypes[RMM.mainSet.squareMapCompassFontType])
	RMM.c.compass.northeast:SetColor(RMM.mainSet.squareMapCompassFontColor.r,RMM.mainSet.squareMapCompassFontColor.g,RMM.mainSet.squareMapCompassFontColor.b,RMM.mainSet.squareMapCompassFontColor.a)
	
	--southwest
	if not RMM.c.compass.southwest then
		RMM.c.compass.southwest = wm:CreateControl("RMM_SQUARE_COMPASS_SOUTHWEST", RMM.c.compass, CT_LABEL)
		RMM.c.compass.southwest:SetHorizontalAlignment( CENTER )
		RMM.c.compass.southwest:SetVerticalAlignment( CENTER )
		RMM.c.compass.southwest:SetDrawLayer(1)
		RMM.c.compass.southwest:SetText("SW")
		RMM.c.compass.southwest.x = -1
		RMM.c.compass.southwest.y = 1
	end
	RMM.c.compass.southwest:SetFont(RMM.fonts[RMM.mainSet.squareMapCompassFont] .. "|" .. RMM.mainSet.squareMapCompassFontSize .. "|" ..  RMM.fontTypes[RMM.mainSet.squareMapCompassFontType])
	RMM.c.compass.southwest:SetColor(RMM.mainSet.squareMapCompassFontColor.r,RMM.mainSet.squareMapCompassFontColor.g,RMM.mainSet.squareMapCompassFontColor.b,RMM.mainSet.squareMapCompassFontColor.a)
	
	
	--southest
	if not RMM.c.compass.southest then
	RMM.c.compass.southest = wm:CreateControl("RMM_SQUARE_COMPASS_SOUTHEAST", RMM.c.compass, CT_LABEL)
	RMM.c.compass.southest:SetHorizontalAlignment( CENTER )
	RMM.c.compass.southest:SetVerticalAlignment( CENTER )
	RMM.c.compass.southest:SetDrawLayer(1)
	RMM.c.compass.southest:SetText("SE")
	RMM.c.compass.southest.x = 1
	RMM.c.compass.southest.y = 1
	end
	RMM.c.compass.southest:SetFont(RMM.fonts[RMM.mainSet.squareMapCompassFont] .. "|" .. RMM.mainSet.squareMapCompassFontSize .. "|" ..  RMM.fontTypes[RMM.mainSet.squareMapCompassFontType])
	RMM.c.compass.southest:SetColor(RMM.mainSet.squareMapCompassFontColor.r,RMM.mainSet.squareMapCompassFontColor.g,RMM.mainSet.squareMapCompassFontColor.b,RMM.mainSet.squareMapCompassFontColor.a)
	
	--player pin
	if not RMM.c.map.ppin then
		RMM.c.map.ppin = wm:CreateControl("RMM_PLAYER", RMM.c.map, CT_TEXTURE)
		RMM.c.map.ppin:SetTexture("RadarMiniMap/asset/player.dds")
		RMM.c.map.ppin:SetAnchor(CENTER, RMM.c.map, CENTER, 0,0)
		RMM.c.map.ppin:SetDrawLayer(3)
	end
	RMM.c.map.ppin:SetDimensions(RMM.mainSet.playerPinSize, RMM.mainSet.playerPinSize)
	RMM.c.map.ppin:SetColor(RMM.mainSet.playerPinColor["r"], RMM.mainSet.playerPinColor["g"], RMM.mainSet.playerPinColor["b"], RMM.mainSet.playerPinColor["a"])
	
	--MiniMenu
	
	--menu horizontal
    if not RMM.c.menuh then
		RMM.c.menuh = wm:CreateControl("RMM_MENU_HORIZONTAL", RMM.c, CT_BACKDROP)
		RMM.c.menuh:SetDrawLayer(0)
		RMM.c.menuh:SetHidden(true)
		RMM.c.menuh:SetMouseEnabled(true)
		RMM.c.menuh:SetCenterColor(0, 0, 0, 0.6)
		RMM.c.menuh:SetEdgeColor(0, 0, 0, 0)
		RMM.c.menuh:SetHandler("OnMouseEnter", RMM.OnMouseEnter)
		RMM.c.menuh:SetHandler("OnMouseExit", RMM.OnMouseExit)
	end
	RMM.c.menuh:SetDimensions(RMM.mainSet.sizeX,32)
	
	--menu vertical
    if not RMM.c.menuv then
		RMM.c.menuv = wm:CreateControl("RMM_MENU_VERTICAL", RMM.c, CT_BACKDROP)
		RMM.c.menuv:SetDrawLayer(0)
		RMM.c.menuv:SetHidden(true)
		RMM.c.menuv:SetMouseEnabled(true)
		RMM.c.menuv:SetCenterColor(0, 0, 0, 0.6)
		RMM.c.menuv:SetEdgeColor(0, 0, 0, 0)
		RMM.c.menuv:SetHandler("OnMouseEnter", RMM.OnMouseEnter)
		RMM.c.menuv:SetHandler("OnMouseExit", RMM.OnMouseExit)
	end
	RMM.c.menuv:SetDimensions(24,RMM.mainSet.sizeY)
	
	--menu corner
    if not RMM.c.menuc then
	RMM.c.menuc = wm:CreateControl("RMM_MENU_CORNER", RMM.c, CT_BACKDROP)
	RMM.c.menuc:SetDimensions(24,32)
	RMM.c.menuc:SetDrawLayer(0)
	RMM.c.menuc:SetHidden(true)
	RMM.c.menuc:SetMouseEnabled(true)
	RMM.c.menuc:SetCenterColor(0, 0, 0, 0.6)
	RMM.c.menuc:SetEdgeColor(0, 0, 0, 0)
	RMM.c.menuc:SetHandler("OnMouseEnter", RMM.OnMouseEnter)
	RMM.c.menuc:SetHandler("OnMouseExit", RMM.OnMouseExit)
	end	
	
	--settingsButton
    if not RMM.c.menuv.setbutton then
		RMM.c.menuv.setbutton = wm:CreateControl("RMM_MENU_SETTINGS", RMM.c.menuv, CT_BUTTON)
		RMM.c.menuv.setbutton:SetDimensions(24,24)
		RMM.c.menuv.setbutton:SetAnchor(CENTER, RMM.c.menuv, TOP, 0, 12)
		RMM.c.menuv.setbutton:SetDrawLayer(1)
		RMM.c.menuv.setbutton:SetNormalTexture("RadarMiniMap/asset/icon_setting.dds")
		RMM.c.menuv.setbutton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
		RMM.c.menuv.setbutton:SetPressedTexture("RadarMiniMap/asset/icon_setting.dds")
		RMM.c.menuv.setbutton:SetMouseEnabled(true)
		RMM.c.menuv.setbutton:SetHandler("OnMouseEnter", function(self) RMM.OnMouseEnter(self,"Open Settings") end)
		RMM.c.menuv.setbutton:SetHandler("OnMouseExit", RMM.OnMouseExit)
		RMM.c.menuv.setbutton:SetHandler("OnMouseUp", function() RMM.lam:OpenToPanel(RadarMiniMap) end)
	end	
	
	--rotationButton
    if not RMM.c.menuv.rotationButton then
		RMM.c.menuv.rotationButton = wm:CreateControl("RMM_MENU_ROTATION", RMM.c.menuv, CT_BUTTON)
		RMM.c.menuv.rotationButton:SetDimensions(24,24)
		RMM.c.menuv.rotationButton:SetAnchor(CENTER, RMM.c.menuv, TOP, 0, 36)
		RMM.c.menuv.rotationButton:SetDrawLayer(1)
		if RMM.mainSet.mapRotation then
			RMM.c.menuv.rotationButton:SetNormalTexture("RadarMiniMap/asset/icon_rotation.dds")
			RMM.c.menuv.rotationButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.rotationButton:SetPressedTexture("RadarMiniMap/asset/icon_rotation.dds")
		else
			RMM.c.menuv.rotationButton:SetNormalTexture("RadarMiniMap/asset/icon_rotation_disabled.dds")
			RMM.c.menuv.rotationButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.rotationButton:SetPressedTexture("RadarMiniMap/asset/icon_rotation_disabled.dds")
		end
		RMM.c.menuv.rotationButton:SetMouseEnabled(true)
		RMM.c.menuv.rotationButton:SetHandler("OnMouseEnter", function(self) RMM.OnMouseEnter(self,"Enable / Disable Rotation") end)
		RMM.c.menuv.rotationButton:SetHandler("OnMouseExit", RMM.OnMouseExit)
		RMM.c.menuv.rotationButton:SetHandler("OnMouseUp", function() RMM.OptionChange("rotation") end)
	end
	
	--headingButton
    if not RMM.c.menuv.headingButton then
		RMM.c.menuv.headingButton = wm:CreateControl("RMM_MENU_HEADING", RMM.c.menuv, CT_BUTTON)
		RMM.c.menuv.headingButton:SetDimensions(24,24)
		RMM.c.menuv.headingButton:SetAnchor(CENTER, RMM.c.menuv, TOP, 0, 60)
		RMM.c.menuv.headingButton:SetDrawLayer(1)
		if RMM.mainSet.heading == "Player" then
			RMM.c.menuv.headingButton:SetNormalTexture("RadarMiniMap/asset/icon_player.dds")
			RMM.c.menuv.headingButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.headingButton:SetPressedTexture("RadarMiniMap/asset/icon_player.dds")
		else
			RMM.c.menuv.headingButton:SetNormalTexture("RadarMiniMap/asset/icon_camera.dds")
			RMM.c.menuv.headingButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.headingButton:SetPressedTexture("RadarMiniMap/asset/icon_camera.dds")
		end
		RMM.c.menuv.headingButton:SetMouseEnabled(true)
		RMM.c.menuv.headingButton:SetHandler("OnMouseEnter", function(self) RMM.OnMouseEnter(self,"Switch Player / Camera Heading") end)
		RMM.c.menuv.headingButton:SetHandler("OnMouseExit", RMM.OnMouseExit)
		RMM.c.menuv.headingButton:SetHandler("OnMouseUp", function() RMM.OptionChange("heading") end)
	end
	
	--pinButton
    if not RMM.c.menuv.pinButton then
		RMM.c.menuv.pinButton = wm:CreateControl("RMM_MENU_PINS", RMM.c.menuv, CT_BUTTON)
		RMM.c.menuv.pinButton:SetDimensions(24,24)
		RMM.c.menuv.pinButton:SetAnchor(CENTER, RMM.c.menuv, TOP, 0, 84)
		RMM.c.menuv.pinButton:SetDrawLayer(1)
		if RMM.mainSet.pinEnabled then
			RMM.c.menuv.pinButton:SetNormalTexture("RadarMiniMap/asset/icon_pin.dds")
			RMM.c.menuv.pinButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.pinButton:SetPressedTexture("RadarMiniMap/asset/icon_pin.dds")
		else
			RMM.c.menuv.pinButton:SetNormalTexture("RadarMiniMap/asset/icon_pin_disabled.dds")
			RMM.c.menuv.pinButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.pinButton:SetPressedTexture("RadarMiniMap/asset/icon_pin_disabled.dds")
		end
		RMM.c.menuv.pinButton:SetMouseEnabled(true)
		RMM.c.menuv.pinButton:SetHandler("OnMouseEnter", function(self) RMM.OnMouseEnter(self,"Enable / Disable Pins") end)
		RMM.c.menuv.pinButton:SetHandler("OnMouseExit", RMM.OnMouseExit)
		RMM.c.menuv.pinButton:SetHandler("OnMouseUp", function() RMM.OptionChange("pin") end)
	end
		
	--filterButton
    if not RMM.c.menuv.filterButton then
		RMM.c.menuv.filterButton = wm:CreateControl("RMM_MENU_FILTER", RMM.c.menuv, CT_BUTTON)
		RMM.c.menuv.filterButton:SetDimensions(24,24)
		RMM.c.menuv.filterButton:SetAnchor(CENTER, RMM.c.menuv, TOP, 0, 108)
		RMM.c.menuv.filterButton:SetDrawLayer(1)
		RMM.c.menuv.filterButton:SetAlpha(0.2)
		if RMM.mainSet.filterEnabled then
			RMM.c.menuv.filterButton:SetNormalTexture("RadarMiniMap/asset/icon_filter.dds")
			RMM.c.menuv.filterButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.filterButton:SetPressedTexture("RadarMiniMap/asset/icon_filter.dds")
		else
			RMM.c.menuv.filterButton:SetNormalTexture("RadarMiniMap/asset/icon_filter_disabled.dds")
			RMM.c.menuv.filterButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.filterButton:SetPressedTexture("RadarMiniMap/asset/icon_filter_disabled.dds")
		end
		RMM.c.menuv.filterButton:SetMouseEnabled(true)
		RMM.c.menuv.filterButton:SetHandler("OnMouseEnter", function(self) RMM.OnMouseEnter(self,"Pin Filter (Coming soon, use map filter)") end)
		RMM.c.menuv.filterButton:SetHandler("OnMouseExit", RMM.OnMouseExit)
		RMM.c.menuv.filterButton:SetHandler("OnMouseUp", function() RMM.OptionChange("filter") end)
	end
		
	--mapZoomSlider
    if not RMM.c.menuh.mapZoomSlider then
		RMM.c.menuh.mapZoomSlider = wm:CreateControl("RMM_MENU_MAPZOOM", RMM.c.menuh, CT_SLIDER)
		RMM.c.menuh.mapZoomSlider:SetThumbTexture("EsoUI/Art/Miscellaneous/scrollbox_elevator.dds", nil, nil, 8, 16)
		RMM.c.menuh.mapZoomSlider:SetAnchor(TOPLEFT, RMM.c.menuh, TOPLEFT, 3, 3)
		RMM.c.menuh.mapZoomSlider:SetDrawLayer(1)
		RMM.c.menuh.mapZoomSlider:SetMouseEnabled(true)
		RMM.c.menuh.mapZoomSlider:SetHandler("OnMouseEnter", function(self) RMM.OnMouseEnter(self,"Map Zoom") end)
		RMM.c.menuh.mapZoomSlider:SetHandler("OnMouseExit", RMM.OnMouseExit)
		RMM.c.menuh.mapZoomSlider:SetHandler("OnMouseWheel", RMM.OnMapMouseWheel)
		RMM.c.menuh.mapZoomSlider:SetMinMax(0.0625, 2.5)
		RMM.c.menuh.mapZoomSlider:SetValueStep(0.0625)
		RMM.c.menuh.mapZoomSlider:SetValue(1)
		RMM.c.menuh.mapZoomSlider:SetOrientation(ORIENTATION_HORIZONTAL)
		RMM.c.menuh.mapZoomSlider:SetHandler("OnValueChanged", function(self,value) RMM.SetZoom(value) end)
	end
	RMM.c.menuh.mapZoomSlider:SetDimensions(RMM.mainSet.sizeX / 256 * 120, 16)
	
	--zoomBg
	if not RMM.c.menuh.mapZoomSlider.bg then
		RMM.c.menuh.mapZoomSlider.bg = wm:CreateControl("RMM_MENU_MAPZOOM_BG", RMM.c.menuh.mapZoomSlider, CT_BACKDROP)
		RMM.c.menuh.mapZoomSlider.bg:SetCenterColor(0, 0, 0)
		RMM.c.menuh.mapZoomSlider.bg:SetAnchor(TOPLEFT, RMM.c.menuh.mapZoomSlider, TOPLEFT, 0, 4)
		RMM.c.menuh.mapZoomSlider.bg:SetAnchor(BOTTOMRIGHT, RMM.c.menuh.mapZoomSlider, BOTTOMRIGHT, 0, -4)
		RMM.c.menuh.mapZoomSlider.bg:SetEdgeTexture("EsoUI\\Art\\Tooltips\\UI-SliderBackdrop.dds", 32, 4)
	end
	
	--zoomLabel
	if not RMM.c.menuh.mapZoomSlider.label then
		RMM.c.menuh.mapZoomSlider.label = wm:CreateControl("RMM_MENU_MAPZOOM_LABEL", RMM.c.menuh.mapZoomSlider, CT_LABEL)
		RMM.c.menuh.mapZoomSlider.label:SetFont("EsoUI/Common/Fonts/ProseAntiquePSMT.otf" .. "|" .. 12 .. "|" .. "none")
		RMM.c.menuh.mapZoomSlider.label:SetColor(1, 0.83, 0.6, 1)
		RMM.c.menuh.mapZoomSlider.label:SetAnchor(TOP, RMM.c.menuh.mapZoomSlider, BOTTOM, 0, -2)
		RMM.c.menuh.mapZoomSlider.label:SetWrapMode(TEXT_WRAP_MODE_ELLIPSIS)
		RMM.c.menuh.mapZoomSlider.label:SetText("Map x 1")
	end
		
	--pinZoomSlider	
	if not RMM.c.menuh.pinZoomSlider then
		RMM.c.menuh.pinZoomSlider = wm:CreateControl("RMM_MENU_PINZOOM", RMM.c.menuh, CT_SLIDER)
		RMM.c.menuh.pinZoomSlider:SetThumbTexture("EsoUI/Art/Miscellaneous/scrollbox_elevator.dds", nil, nil, 8, 16)
		RMM.c.menuh.pinZoomSlider:SetAnchor(TOPRIGHT, RMM.c.menuh, TOPRIGHT, -3, 3)
		RMM.c.menuh.pinZoomSlider:SetDrawLayer(1)
		RMM.c.menuh.pinZoomSlider:SetMouseEnabled(true)
		RMM.c.menuh.pinZoomSlider:SetHandler("OnMouseEnter", function(self) RMM.OnMouseEnter(self,"Pin Zoom") end)
		RMM.c.menuh.pinZoomSlider:SetHandler("OnMouseExit", RMM.OnMouseExit)
		RMM.c.menuh.pinZoomSlider:SetHandler("OnMouseWheel", RMM.OnPinMouseWheel)
		RMM.c.menuh.pinZoomSlider:SetMinMax(0.0625, 2.5)
		RMM.c.menuh.pinZoomSlider:SetValueStep(0.0625)
		RMM.c.menuh.pinZoomSlider:SetValue(1)
		RMM.c.menuh.pinZoomSlider:SetOrientation(ORIENTATION_HORIZONTAL)
		RMM.c.menuh.pinZoomSlider:SetHandler("OnValueChanged", function(self,value) RMM.mainSet.pinSize = value; RMM.WorldMapUpdate(); RMM.c.menuh.pinZoomSlider.label:SetText("Pin x "..value) end)
	end
	RMM.c.menuh.pinZoomSlider:SetDimensions(RMM.mainSet.sizeX / 256 * 120, 16)
	
	--pinZoomBg
	if not RMM.c.menuh.pinZoomSlider.bg then
		RMM.c.menuh.pinZoomSlider.bg = wm:CreateControl("RMM_MENU_PINZOOM_BG", RMM.c.menuh.pinZoomSlider, CT_BACKDROP)
		RMM.c.menuh.pinZoomSlider.bg:SetCenterColor(0, 0, 0)
		RMM.c.menuh.pinZoomSlider.bg:SetAnchor(TOPLEFT, RMM.c.menuh.pinZoomSlider, TOPLEFT, 0, 4)
		RMM.c.menuh.pinZoomSlider.bg:SetAnchor(BOTTOMRIGHT, RMM.c.menuh.pinZoomSlider, BOTTOMRIGHT, 0, -4)
		RMM.c.menuh.pinZoomSlider.bg:SetEdgeTexture("EsoUI\\Art\\Tooltips\\UI-SliderBackdrop.dds", 32, 4)
	end
		
	--pinZoomLabel
	if not RMM.c.menuh.pinZoomSlider.label then
		RMM.c.menuh.pinZoomSlider.label = wm:CreateControl("RMM_MENU_PINZOOM_LABEL", RMM.c.menuh.pinZoomSlider, CT_LABEL)
		RMM.c.menuh.pinZoomSlider.label:SetFont("EsoUI/Common/Fonts/ProseAntiquePSMT.otf" .. "|" .. 12 .. "|" ..  "none")
		RMM.c.menuh.pinZoomSlider.label:SetColor(1, 0.83, 0.6, 1)
		RMM.c.menuh.pinZoomSlider.label:SetAnchor(TOP, RMM.c.menuh.pinZoomSlider, BOTTOM, 0, -2)
		RMM.c.menuh.pinZoomSlider.label:SetWrapMode(TEXT_WRAP_MODE_ELLIPSIS)
		RMM.c.menuh.pinZoomSlider.label:SetText("Pin x "..RMM.mainSet.pinSize)
	end
		
	--tooltip
	if not RMM.c.tooltip then
		RMM.c.tooltip = wm:CreateControl("RMM_MENU_TOOLTIP", RMM.c, CT_LABEL)
		RMM.c.tooltip:SetFont("EsoUI/Common/Fonts/ProseAntiquePSMT.otf" .. "|" .. 12 .. "|" ..  "none")
		RMM.c.tooltip:SetColor(1, 0.83, 0.6, 1)
		RMM.c.tooltip:SetWrapMode(TEXT_WRAP_MODE_ELLIPSIS)
		RMM.c.tooltip:SetDrawLayer(1)
		RMM.c.tooltip:SetDrawTier(2)
		RMM.c.tooltip:SetHidden(true)
		RMM.c.tooltip:SetHandler("OnTextChanged", function() RMM.c.tooltip.bg:SetDimensions(RMM.c.tooltip:GetWidth() + 10,RMM.c.tooltip:GetHeight() + 10) end)
	end
	
	--tooltipBg
	if not RMM.c.tooltip.bg then
		RMM.c.tooltip.bg = wm:CreateControl("RMM_MENU_TOOLTIP_BG", RMM.c.tooltip, CT_BACKDROP)
		RMM.c.tooltip.bg:SetDrawLayer(0)
		RMM.c.tooltip.bg:SetDrawTier(2)
		RMM.c.tooltip.bg:SetAnchor(TOPLEFT, RMM.c.tooltip, TOPLEFT, -6, -4)
		RMM.c.tooltip.bg:SetAnchor(BOTTOMRIGHT, RMM.c.tooltip, BOTTOMRIGHT, 6, 4)
		RMM.c.tooltip.bg:SetEdgeTexture("EsoUI\\Art\\Tooltips\\UI-Border.dds", 128, 16)
		RMM.c.tooltip.bg:SetCenterTexture("EsoUI\\Art\\Tooltips\\UI-TooltipCenter.dds")
	end
	
	--InformationTooltip
	if not RMM.c.informationTooltip then
		RMM.c.informationTooltip = wm:CreateControlFromVirtual("RMM_INFORMATION_TOOLTIP", RMM.c, "ZO_BaseTooltip")
		RMM.c.informationTooltip:SetFont("EsoUI/Common/Fonts/ProseAntiquePSMT.otf" .. "|" .. 10 .. "|" .. "none")
		RMM.c.informationTooltip:SetDrawLayer(1)
		RMM.c.informationTooltip:SetDrawTier(2)
		local bg = RMM.c.informationTooltip:GetNamedChild("BG")
		bg:ClearAnchors()
		bg:SetAnchor(TOPLEFT, RMM.c.informationTooltip, TOPLEFT, 6, 6)
		bg:SetAnchor(BOTTOMRIGHT, RMM.c.informationTooltip, BOTTOMRIGHT, -6, -10)
	end
	
	--location Name first
	if not RMM.c.locationNameFirst then
		RMM.c.locationNameFirst = wm:CreateControl("RMM_LOCATION_NAME_FIRST", RMM.c, CT_LABEL)
		RMM.c.locationNameFirst:SetHorizontalAlignment( CENTER )
		RMM.c.locationNameFirst:SetVerticalAlignment( CENTER )
		RMM.c.locationNameFirst:SetDrawLayer(1)
	end
	RMM.c.locationNameFirst:SetColor(RMM.mainSet.locationFontColor.r, RMM.mainSet.locationFontColor.g, RMM.mainSet.locationFontColor.b, RMM.mainSet.locationFontColor.a)
	RMM.c.locationNameFirst:SetFont(RMM.fonts[RMM.mainSet.locationFont] .. "|" .. RMM.mainSet.locationFontSize .. "|" ..  RMM.fontTypes[RMM.mainSet.locationFontType])
	
	--location Name second
	if not RMM.c.locationNameSecond then
		RMM.c.locationNameSecond = wm:CreateControl("RMM_LOCATION_NAME_SECOND", RMM.c, CT_LABEL)
		RMM.c.locationNameSecond:SetHorizontalAlignment( CENTER )
		RMM.c.locationNameSecond:SetVerticalAlignment( CENTER )
		RMM.c.locationNameSecond:SetDrawLayer(1)
	end
	RMM.c.locationNameSecond:SetColor(RMM.mainSet.locationFontColor.r, RMM.mainSet.locationFontColor.g, RMM.mainSet.locationFontColor.b, RMM.mainSet.locationFontColor.a)
	RMM.c.locationNameSecond:SetFont(RMM.fonts[RMM.mainSet.locationFont] .. "|" .. RMM.mainSet.locationFontSize .. "|" ..  RMM.fontTypes[RMM.mainSet.locationFontType])
	
	RMM.MenuPos()

end


--QuickOptions
function RMM.OptionChange(str)

	if str == "rotation" then
		if RMM.mainSet.mapRotation then
			RMM.c.menuv.rotationButton:SetNormalTexture("RadarMiniMap/asset/icon_rotation_disabled.dds")
			RMM.c.menuv.rotationButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.rotationButton:SetPressedTexture("RadarMiniMap/asset/icon_rotation_disabled.dds")
			RMM.mainSet.mapRotation = false
		else
			RMM.c.menuv.rotationButton:SetNormalTexture("RadarMiniMap/asset/icon_rotation.dds")
			RMM.c.menuv.rotationButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.rotationButton:SetPressedTexture("RadarMiniMap/asset/icon_rotation.dds")
			RMM.mainSet.mapRotation = true
		end
	end
	
	if str == "heading" then
		if RMM.mainSet.heading == "Player" then
			RMM.c.menuv.headingButton:SetNormalTexture("RadarMiniMap/asset/icon_camera.dds")
			RMM.c.menuv.headingButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.headingButton:SetPressedTexture("RadarMiniMap/asset/icon_camera.dds")
			RMM.mainSet.heading = "Camera"
		else
			RMM.c.menuv.headingButton:SetNormalTexture("RadarMiniMap/asset/icon_player.dds")
			RMM.c.menuv.headingButton:SetMouseOverTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.headingButton:SetPressedTexture("RadarMiniMap/asset/icon_player.dds")
			RMM.mainSet.heading = "Player"
		end
	end
	
	if	str == "pin" then
		if RMM.mainSet.pinEnabled then
			RMM.c.menuv.pinButton:SetNormalTexture("RadarMiniMap/asset/icon_pin_disabled.dds")
			RMM.c.menuv.pinButton:SetNormalTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.pinButton:SetNormalTexture("RadarMiniMap/asset/icon_pin_disabled.dds")
			RMM.mainSet.pinEnabled = false
		else
			RMM.c.menuv.pinButton:SetNormalTexture("RadarMiniMap/asset/icon_pin.dds")
			RMM.c.menuv.pinButton:SetNormalTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.pinButton:SetNormalTexture("RadarMiniMap/asset/icon_pin.dds")
			RMM.mainSet.pinEnabled = true
		end
		RMM.WorldMapUpdate()
	end
	
	if	str == "filter" then
		if RMM.mainSet.filterEnabled then
			RMM.c.menuv.filterButton:SetNormalTexture("RadarMiniMap/asset/icon_filter_disabled.dds")
			RMM.c.menuv.filterButton:SetNormalTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.filterButton:SetNormalTexture("RadarMiniMap/asset/icon_filter_disabled.dds")
			RMM.mainSet.filterEnabled = false
		else
			RMM.c.menuv.filterButton:SetNormalTexture("RadarMiniMap/asset/icon_filter.dds")
			RMM.c.menuv.filterButton:SetNormalTexture("/esoui/art/buttons/generic_highlight.dds")
			RMM.c.menuv.filterButton:SetNormalTexture("RadarMiniMap/asset/icon_filter.dds")
			RMM.mainSet.filterEnabled = true
		end
	end

end

--Tooltip
function RMM.ToolTip(tooltipText)
	
	local screenX, screenY = GuiRoot:GetWidth(), GuiRoot:GetHeight()
	
	RMM.c.tooltip:ClearAnchors()		
	if GuiMouse:GetLeft() > screenX * 0.9 and GuiMouse:GetTop() > screenY * 0.9 then RMM.c.tooltip:SetAnchor(BOTTOMRIGHT, GuiMouse, TOPLEFT, -20, -20) end
	if GuiMouse:GetLeft() < screenX * 0.9 and GuiMouse:GetTop() > screenY * 0.9 then RMM.c.tooltip:SetAnchor(BOTTOMLEFT, GuiMouse, TOPLEFT, 20, -20) end
	if GuiMouse:GetLeft() > screenX * 0.9 and GuiMouse:GetTop() < screenY * 0.9 then RMM.c.tooltip:SetAnchor(TOPRIGHT, GuiMouse, TOPLEFT, -20, 20) end
	if GuiMouse:GetLeft() < screenX * 0.9 and GuiMouse:GetTop() < screenY * 0.9 then RMM.c.tooltip:SetAnchor(TOPLEFT, GuiMouse, TOPLEFT, 20, 20) end	
	
	RMM.c.tooltip:SetText(tooltipText)
	
end

--On Mouse Enter
function RMM.OnMouseEnter(ctrl, tooltipText)

	RMM.c.hover:SetHidden(false)
	RMM.c.menuh:SetHidden(false)
	RMM.c.menuv:SetHidden(false)
	RMM.c.menuc:SetHidden(false)
	RMM.c.locationNameFirst:SetHidden(true)
	RMM.c.locationNameSecond:SetHidden(true)
	
	if tooltipText then
		RMM.ToolTip(tooltipText)
		RMM.c.tooltip:SetHidden(false)
	end
	
end

--On Mouse Exit
function RMM.OnMouseExit()

	RMM.c.hover:SetHidden(true)
	RMM.c.menuh:SetHidden(true)
	RMM.c.menuv:SetHidden(true)
	RMM.c.menuc:SetHidden(true)
	RMM.c.locationNameFirst:SetHidden(false)
	RMM.c.locationNameSecond:SetHidden(false)
	
	RMM.c.tooltip:SetHidden(true)
	
end

function RMM.OnResizeStart(self)

	RMM.resize = true
	
end

function RMM.WhileResize()
	
	local sizeX, sizeY = RMM.c:GetDimensions()
	sizeX, sizeY = math.floor(sizeX), math.floor(sizeY)
	local scale = 1
	
	if sizeX < 128 then sizeX = 128 end
	if sizeY < 128 then sizeY = 128 end
	
	if RMM.mainSet.squareMap then
		if RMM.mainSet.sizeX == sizeX or RMM.mainSet.sizeY == sizeY then
			RMM.mainSet.sizeY = sizeY
			RMM.mainSet.sizeX = sizeX
		else
			RMM.mainSet.sizeY = ( sizeX + sizeY ) / 2
			RMM.mainSet.sizeX = ( sizeX + sizeY ) / 2
		end
	else
		if RMM.mainSet.sizeX == sizeX then
			RMM.mainSet.sizeY = sizeY
			RMM.mainSet.sizeX = sizeY
		elseif RMM.mainSet.sizeY == sizeY then
			RMM.mainSet.sizeY = sizeX
			RMM.mainSet.sizeX = sizeX
		else
			RMM.mainSet.sizeY = ( sizeX + sizeY ) / 2
			RMM.mainSet.sizeX = ( sizeX + sizeY ) / 2
		end
	end
	
	RMM.CreateUI()

end

--On Resize Stop
function RMM.OnResizeStop(self)
	RMM.resize = false
end

--On Map Mouse Wheel
function RMM.OnMapMouseWheel(self, delta)
	
	local mapTyp = RMM.map[RMM.mapName]["mapTyp"]
	local mapContentType = RMM.map[RMM.mapName]["mapContentType"]
	local mapZoom = RMM.mainSet.zoom[mapTyp..mapContentType]
	
	mapZoom = mapZoom + (delta / 16)
	
	if mapZoom < 0.0625 then
		RMM.c.menuh.mapZoomSlider:SetValue(0.0625)
	elseif mapZoom > 2.5 then
		RMM.c.menuh.mapZoomSlider:SetValue(2.5)
	else
		RMM.c.menuh.mapZoomSlider:SetValue(mapZoom)
	end
	
end

--On Pin Mouse Wheel
function RMM.OnPinMouseWheel(self, delta)
	
	local pinZoom = self:GetValue() + (delta / 16)
	
	if pinZoom < 0.0625 then
		self:SetValue(0.0625)
	elseif pinZoom > 2.5 then
		self:SetValue(2.5)
	else
		self:SetValue(pinZoom)
	end
	
end

--On Move Stop
function RMM.OnMoveStop()

	RMM.mainSet.positionX = math.floor(RMM.c:GetLeft())
	RMM.mainSet.positionY = math.floor(RMM.c:GetTop())

	RMM.MenuPos()
	
end

--MenuPos
function RMM.MenuPos()

	local screenX, screenY = GuiRoot:GetWidth(), GuiRoot:GetHeight()
	local right, bottom, top, left = RMM.c:GetRight(), RMM.c:GetBottom(), RMM.c:GetTop(), RMM.c:GetLeft()
	
	local qMA = RMM.mainSet.quickMenuAnchor
	
	RMM.c.menuv:ClearAnchors()
	RMM.c.menuh:ClearAnchors()
	RMM.c.menuc:ClearAnchors()
	RMM.c.locationNameFirst:ClearAnchors()
	RMM.c.locationNameSecond:ClearAnchors()
	
	if qMA == "AUTO" then
		if ( left < screenX * 0.1 and bottom < screenY * 0.9 ) then
			qMA = "BOTTOMRIGHT"
		elseif ( left < screenX * 0.1 and bottom > screenY * 0.9 ) then
			qMA = "TOPRIGHT"
		elseif ( left > screenX * 0.1 and bottom > screenY * 0.9 ) then
			qMA = "TOPLEFT"
		else
			qMA = "BOTTOMLEFT"
		end
	end
	
	if qMA == "BOTTOMRIGHT" then
		RMM.c.menuv:SetAnchor(LEFT, RMM.c, RIGHT, 0, 0)
		RMM.c.menuh:SetAnchor(TOP, RMM.c, BOTTOM, 0, 0)
		RMM.c.menuc:SetAnchor(TOPLEFT, RMM.c, BOTTOMRIGHT, 0, 0)
		RMM.c.locationNameFirst:SetAnchor(BOTTOM, RMM.c.menuh, CENTER, 0, 4)
		RMM.c.locationNameSecond:SetAnchor(TOP, RMM.c.menuh, CENTER, 0, 0)
		RMM.tooltipAnchor = TOPLEFT
	elseif qMA == "TOPRIGHT" then
		RMM.c.menuv:SetAnchor(LEFT, RMM.c, RIGHT, 0, 0)
		RMM.c.menuh:SetAnchor(BOTTOM, RMM.c, TOP, 0, 0)
		RMM.c.menuc:SetAnchor(BOTTOMLEFT, RMM.c, TOPRIGHT, 0, 0)
		RMM.c.locationNameFirst:SetAnchor(TOP, RMM.c.menuh, CENTER, 0, -4)
		RMM.c.locationNameSecond:SetAnchor(BOTTOM, RMM.c.menuh, CENTER, 0, 0)
		RMM.tooltipAnchor = TOPLEFT
	elseif qMA == "TOPLEFT" then
		RMM.c.menuv:SetAnchor(RIGHT, RMM.c, LEFT, 0, 0)
		RMM.c.menuh:SetAnchor(BOTTOM, RMM.c, TOP, 0, 0)
		RMM.c.menuc:SetAnchor(BOTTOMRIGHT, RMM.c, TOPLEFT, 0, 0)
		RMM.c.locationNameFirst:SetAnchor(TOP, RMM.c.menuh, CENTER, 0, -4)
		RMM.c.locationNameSecond:SetAnchor(BOTTOM, RMM.c.menuh, CENTER, 0, 0)
		RMM.tooltipAnchor = TOPRIGHT
	elseif qMA == "BOTTOMLEFT" then
		RMM.c.menuv:SetAnchor(RIGHT, RMM.c, LEFT, 0, 0)
		RMM.c.menuh:SetAnchor(TOP, RMM.c, BOTTOM, 0, 0)
		RMM.c.menuc:SetAnchor(TOPRIGHT, RMM.c, BOTTOMLEFT, 0, 0)
		RMM.c.locationNameFirst:SetAnchor(BOTTOM, RMM.c.menuh, CENTER, 0, 4)
		RMM.c.locationNameSecond:SetAnchor(TOP, RMM.c.menuh, CENTER, 0, 0)
		RMM.tooltipAnchor = TOPRIGHT
	end
	
end