--[[----------------------------------------------------------
	RadarMiniMap Update
--]]----------------------------------------------------------

function RMM.OnGroupUpdate()

	if RMM.c:IsHidden() then return end
	
	local groupNum = GetGroupSize()
	
	RMM.CreateGroupPins(groupNum)
	
end

function RMM.OnLinkUpdate()

	if RMM.c:IsHidden() then return end
	
	local linkNum = ZO_WorldMapContainerKeepLinks:GetNumChildren()
	
	RMM.CreateLinksAndLocks(linkNum)
	
end

function RMM.OnPosUpdate()
	
	RMM.HideCheck()
	
	if RMM.c:IsHidden() then return end
	
	local zoom = RMM.GetZoom()
	local mapName = GetMapName().."_"..GetMapFloorInfo()
	
	if RMM.resize then RMM.WhileResize() end
	RMM.UpdateMap(mapName, zoom)
	
	if mapName == RMM.mapName and zoom == RMM.mapZoom and RMM.InRange() then
		if RMM.PlayerPosChanged() then
			RMM.CreateLocationName(GetMapName(), GetPlayerLocationName())
			if not RMM.c.back.active then RMM.c.back:SetHidden(true) end
			RMM.c.map:SetHidden(false)
			RMM.SetPPinCir(RMM.mainSet.mapRotation)
			RMM.SetWheelCir(RMM.mainSet.mapRotation)
			RMM.SetMapPos(RMM.mainSet.mapRotation)
			RMM.SetPinPos(RMM.mainSet.mapRotation)
			RMM.SetLinkPos(RMM.mainSet.mapRotation)
			RMM.SetGroupPinPos(RMM.mainSet.mapRotation)
		end
	elseif not RMM.InRange() then
		RMM.c.map:SetHidden(true)
		RMM.SetWheelCir(RMM.mainSet.mapRotation)
		RMM.CreateLocationName(GetMapName(), GetPlayerLocationName())
		if not RMM.c.back.active then RMM.c.back:SetHidden(false) end
	else
		RMM.c.map:SetHidden(true)
		RMM.CreateLocationName("Loading...", "")
		if not RMM.c.back.active then RMM.c.back:SetHidden(false) end
	end
	
end

local aniCount = 0
local aniTabel = {
	[0] = {0, 0.25, 0, 1},
	[1] = {0.25, 0.5, 0, 1},
	[2] = {0.5, 0.75, 0, 1},
	[3] = {0.75, 1, 0, 1},
	[4] = {0.5, 0.75, 0, 1},
	[5] = {0.25, 0.5, 0, 1}
}
function RMM.OnAnimationUpdate()
	
	for _,mmPin in pairs(RMM.pinAnimations) do
		mmPin:SetTextureCoords(unpack(aniTabel[aniCount]))
	end
	
	if aniCount < 5 then aniCount = aniCount + 1 else aniCount = 1 end
end